var search_data = {"index":{"searchIndex":["perfectworld","cli","clipboard","clipboardnotavailable","corrupteddatabase","db","error","keynotfound","random","storage","<<()","[]()","available?()","backup()","changed?()","commit()","database()","decrypt()","delete()","delete()","deserialize()","dump()","each()","encrypt()","fetch()","find_key()","generate()","generate()","generate!()","get()","length()","list()","load()","load()","new()","new()","new()","new()","new()","open()","open()","owner()","password_not_found()","print_config()","print_or_copy_to_clipboard()","read()","run()","run()","save()","serialize()","string()","valid?()","write()"],"longSearchIndex":["perfectworld","perfectworld::cli","perfectworld::clipboard","perfectworld::clipboardnotavailable","perfectworld::corrupteddatabase","perfectworld::db","perfectworld::error","perfectworld::keynotfound","perfectworld::random","perfectworld::storage","perfectworld::clipboard::<<()","perfectworld::db#[]()","perfectworld::clipboard::available?()","perfectworld::cli#backup()","perfectworld::db#changed?()","perfectworld::storage::commit()","perfectworld::cli#database()","perfectworld::storage::decrypt()","perfectworld::cli#delete()","perfectworld::db#delete()","perfectworld::storage::deserialize()","perfectworld::storage::dump()","perfectworld::db#each()","perfectworld::storage::encrypt()","perfectworld::db#fetch()","perfectworld::storage::find_key()","perfectworld::cli#generate()","perfectworld::db#generate()","perfectworld::db#generate!()","perfectworld::cli#get()","perfectworld::cli#length()","perfectworld::cli#list()","perfectworld::db::load()","perfectworld::storage::load()","perfectworld::cli::new()","perfectworld::clipboardnotavailable::new()","perfectworld::corrupteddatabase::new()","perfectworld::db::new()","perfectworld::keynotfound::new()","perfectworld::db::open()","perfectworld::storage::open()","perfectworld::cli#owner()","perfectworld::cli#password_not_found()","perfectworld::cli#print_config()","perfectworld::cli#print_or_copy_to_clipboard()","perfectworld::clipboard::read()","perfectworld::cli#run()","perfectworld::clipboard::run()","perfectworld::db#save()","perfectworld::storage::serialize()","perfectworld::random::string()","perfectworld::db::valid?()","perfectworld::clipboard::write()"],"info":[["PerfectWorld","","PerfectWorld.html","",""],["PerfectWorld::Cli","","PerfectWorld/Cli.html","",""],["PerfectWorld::Clipboard","","PerfectWorld/Clipboard.html","","<p>Writes/Reads data from/to the users clipboard.\n<p>Works in graphical environments only. So it is not available …\n"],["PerfectWorld::ClipboardNotAvailable","","PerfectWorld/ClipboardNotAvailable.html","","<p>Should be raised, when no clipboard tool could be found.\n"],["PerfectWorld::CorruptedDatabase","","PerfectWorld/CorruptedDatabase.html","","<p>Should be raised, when a database corruption is detected.\n"],["PerfectWorld::DB","","PerfectWorld/DB.html","","<p>Handles the password database.\n"],["PerfectWorld::Error","","PerfectWorld/Error.html","","<p>Base error for all perfect world errors.\n"],["PerfectWorld::KeyNotFound","","PerfectWorld/KeyNotFound.html","","<p>Should be raised, when gpg key could not be found.\n"],["PerfectWorld::Random","","PerfectWorld/Random.html","","<p>Random string generator.\n"],["PerfectWorld::Storage","","PerfectWorld/Storage.html","",""],["<<","PerfectWorld::Clipboard","PerfectWorld/Clipboard.html#method-c-3C-3C","(s)",""],["[]","PerfectWorld::DB","PerfectWorld/DB.html#method-i-5B-5D","(id)","<p>Returns the password for the id or nil, if not found.\n"],["available?","PerfectWorld::Clipboard","PerfectWorld/Clipboard.html#method-c-available-3F","()","<p>Returns true if the clipboard is available, else false.\n"],["backup","PerfectWorld::Cli","PerfectWorld/Cli.html#method-i-backup","(db, path)","<p>Saves db to another location.\n"],["changed?","PerfectWorld::DB","PerfectWorld/DB.html#method-i-changed-3F","()","<p>Returns true, when the database has changed, else false.\n"],["commit","PerfectWorld::Storage","PerfectWorld/Storage.html#method-c-commit","(data, path)",""],["database","PerfectWorld::Cli","PerfectWorld/Cli.html#method-i-database","(_ = nil, _ = nil)","<p>Prints the path to the currently used database.\n"],["decrypt","PerfectWorld::Storage","PerfectWorld/Storage.html#method-c-decrypt","(data)",""],["delete","PerfectWorld::Cli","PerfectWorld/Cli.html#method-i-delete","(db, id)","<p>Deletes a password.\n"],["delete","PerfectWorld::DB","PerfectWorld/DB.html#method-i-delete","(id)","<p>Deletes the password from the database.\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">store</span>.<span class=\"ruby-identifier\">delete</span>(<span class=\"ruby-value\">:google</span>)\n<span class=\"ruby-comment\">#=&gt; &quot;B6m/![)A%fqw,\\\\ti-d`4\\&quot;&amp;0&gt;gl+&gt;$0$Z&quot; ...</span>\n</pre>\n"],["deserialize","PerfectWorld::Storage","PerfectWorld/Storage.html#method-c-deserialize","(data)",""],["dump","PerfectWorld::Storage","PerfectWorld/Storage.html#method-c-dump","(data, recipient, path)","<p>Writes data into an encrypted file.\n\n<pre>PerfectWorld::Storage.dump([1, 2], &#39;gpguid&#39;, /path/to/file.yml.gpg&#39;)</pre>\n"],["each","PerfectWorld::DB","PerfectWorld/DB.html#method-i-each","(&block)","<p>Iterates over all passwords.\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">store</span>.<span class=\"ruby-identifier\">each</span> <span class=\"ruby-keyword\">do</span> <span class=\"ruby-operator\">|</span><span class=\"ruby-identifier\">id</span>, <span class=\"ruby-identifier\">password</span><span class=\"ruby-operator\">|</span>\n  <span class=\"ruby-identifier\">puts</span> <span class=\"ruby-node\">&quot;#{password}   #{id}&quot;</span>\n<span class=\"ruby-keyword\">end</span>\n</pre>\n<p>Returns an enumerator, …\n"],["encrypt","PerfectWorld::Storage","PerfectWorld/Storage.html#method-c-encrypt","(data, key)",""],["fetch","PerfectWorld::DB","PerfectWorld/DB.html#method-i-fetch","(id, *default)","<p>Fetches a password from the database. It behaves like Hash#fetch.\n"],["find_key","PerfectWorld::Storage","PerfectWorld/Storage.html#method-c-find_key","(term = nil)","<p>Finds a secret key in the key ring.\n<p>Returns GPGME::Key or raises PerfectWorld::KeyNotFound.\n"],["generate","PerfectWorld::Cli","PerfectWorld/Cli.html#method-i-generate","(db, id)","<p>Generats a new password and sends it to stdout.\n"],["generate","PerfectWorld::DB","PerfectWorld/DB.html#method-i-generate","(id, len = 64)","<p>Generates a new password and puts it in the database.\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">store</span>.<span class=\"ruby-identifier\">generate</span>(<span class=\"ruby-value\">:google</span>, <span class=\"ruby-value\">32</span>)\n<span class=\"ruby-comment\">#=&gt; &quot;B6m/![)A%fqw,\\\\ti-d`4\\&quot;&amp;0&gt;gl+&gt;$0$Z&quot; ...</span>\n</pre>\n"],["generate!","PerfectWorld::DB","PerfectWorld/DB.html#method-i-generate-21","(id, len = 64)","<p>Does the same as DB#generate, but overrides existing passwords.\n"],["get","PerfectWorld::Cli","PerfectWorld/Cli.html#method-i-get","(db, id)","<p>Fetches the password and sends it to stdout.\n"],["length","PerfectWorld::Cli","PerfectWorld/Cli.html#method-i-length","(_ = nil, _ = nil)","<p>Prints the currently used password length.\n"],["list","PerfectWorld::Cli","PerfectWorld/Cli.html#method-i-list","(db, _ = nil)","<p>Lists all passwords.\n"],["load","PerfectWorld::DB","PerfectWorld/DB.html#method-c-load","(path)","<p>Loads the database.\n"],["load","PerfectWorld::Storage","PerfectWorld/Storage.html#method-c-load","(path)","<p>Loads data from an encrypted file.\n\n<pre class=\"ruby\"><span class=\"ruby-constant\">PerfectWorld</span><span class=\"ruby-operator\">::</span><span class=\"ruby-constant\">Storage</span>.<span class=\"ruby-identifier\">load</span>(<span class=\"ruby-string\">&#39;path/to/file.yml.gpg&#39;</span>)  <span class=\"ruby-comment\">#=&gt; [1, 2]</span>\n</pre>\n<p>Returns …\n"],["new","PerfectWorld::Cli","PerfectWorld/Cli.html#method-c-new","(config = {})","<p>Sets the config.\n"],["new","PerfectWorld::ClipboardNotAvailable","PerfectWorld/ClipboardNotAvailable.html#method-c-new","()",""],["new","PerfectWorld::CorruptedDatabase","PerfectWorld/CorruptedDatabase.html#method-c-new","(database)",""],["new","PerfectWorld::DB","PerfectWorld/DB.html#method-c-new","(passwords = {})","<p>Inits the db and sets the initial passwords.\n"],["new","PerfectWorld::KeyNotFound","PerfectWorld/KeyNotFound.html#method-c-new","(owner)",""],["open","PerfectWorld::DB","PerfectWorld/DB.html#method-c-open","(path, owner = nil)",""],["open","PerfectWorld::Storage","PerfectWorld/Storage.html#method-c-open","(path)",""],["owner","PerfectWorld::Cli","PerfectWorld/Cli.html#method-i-owner","(_ = nil, _ = nil)","<p>Prints the current key owner.\n"],["password_not_found","PerfectWorld::Cli","PerfectWorld/Cli.html#method-i-password_not_found","(id)","<p>Raises an error with a proper message.\n"],["print_config","PerfectWorld::Cli","PerfectWorld/Cli.html#method-i-print_config","(key)","<p>Prints a config entry.\n"],["print_or_copy_to_clipboard","PerfectWorld::Cli","PerfectWorld/Cli.html#method-i-print_or_copy_to_clipboard","(id, password)","<p>Prints a password or copies it to the clipboard.\n"],["read","PerfectWorld::Clipboard","PerfectWorld/Clipboard.html#method-c-read","()","<p>Reads a string from the clipboard.\n"],["run","PerfectWorld::Cli","PerfectWorld/Cli.html#method-i-run","(commands)","<p>Loads the database and executes the provided commands.\n"],["run","PerfectWorld::Clipboard","PerfectWorld/Clipboard.html#method-c-run","()","<p>Wraps the system calls to catch errors.\n"],["save","PerfectWorld::DB","PerfectWorld/DB.html#method-i-save","(path, owner = nil)","<p>Encryptes the database and writes it to disk.\n"],["serialize","PerfectWorld::Storage","PerfectWorld/Storage.html#method-c-serialize","(data)",""],["string","PerfectWorld::Random","PerfectWorld/Random.html#method-c-string","(len = 64)","<p>Generates a random string with of a specified length (64 by default).\n\n<pre class=\"ruby\"><span class=\"ruby-constant\">PerfectWorld</span><span class=\"ruby-operator\">::</span><span class=\"ruby-constant\">Random</span>.<span class=\"ruby-identifier\">string</span>(<span class=\"ruby-value\">32</span>) <span class=\"ruby-operator\">...</span>\n</pre>\n"],["valid?","PerfectWorld::DB","PerfectWorld/DB.html#method-c-valid-3F","(data)","<p>Checks if a password hash is valid. A valid object is a hash with string values.\n<p>Returns true if it is …\n"],["write","PerfectWorld::Clipboard","PerfectWorld/Clipboard.html#method-c-write","(s)","<p>Writes a string to the clipboard.\n"]]}}